/*****************************************************************************
 *                                18fUtil.h                                  *
 *****************************************************************************
 
Utility functions and types for the StickBot Controller using the PIC18Fxxx

Date:		Author:				Comment:
------------------------------------------------------------------------------
2006-7-3	Barrett Heyneman	First version, writing to abstract out some
								useful functions/types which may be used in
								multiple modules.

*****************************************************************************/

#ifndef __18FUTIL_H
#define __18FUTIL_H


/*****************************************************************************
					PUBLIC TYPES, MACROS, DEFINITIONS
*****************************************************************************/

/* Bit definitions */
#define BIT0		0b00000001
#define BIT1		0b00000010
#define BIT2		0b00000100
#define BIT3		0b00001000
#define BIT4		0b00010000
#define BIT5		0b00100000
#define BIT6		0b01000000
#define BIT7		0b10000000


/* Representation of a byte which gives access directly to the bits */
typedef union {
	struct {
		unsigned bit0:1;
		unsigned bit1:1;
		unsigned bit2:1;
		unsigned bit3:1;
		unsigned bit4:1;
		unsigned bit5:1;
		unsigned bit6:1;
		unsigned bit7:1;
	};
	unsigned char byte;
} Byte_t;

/* Macros for delays */
#define Milliseconds(t1)	Delay10KTCYx(t1)
#define Microseconds(t2)	Delay10TCYx(t2)

/* System clock speed (for use with timers and USART) */
#define FOSC		40000	//KHz


/*****************************************************************************
						PUBLIC FUNCTION PROTOTYPES
*****************************************************************************/

#endif //__18FUTIL_H
